//+------------------------------------------------------------------+
//|                                                         SATL.mq4 |
//|                                                          Valmars |
//|                                         valmars@mail.primorye.ru |
//+------------------------------------------------------------------+
#property copyright "Valmars"
#property link      "valmars@mail.primorye.ru"
#include <stdlib.mqh>
#include <stderror.mqh>
//---- input parameters
extern int TakeProfit = 0;
extern int StopLoss = 0;
extern int TrailingStop = 0; 
extern int MinProfit = 0;
extern int TrailingStep = 0;
extern int MAGIC=0;
extern int Pips=0;
extern int Body=0; // Min    
extern double Lots = 1.0;
extern double risk=10; 
extern int Period_at_minute=0;// 0-. , 1,5,15,30,60,240,1440-. . .  
extern int MaxOrders = 3; //Max     
extern double MinDepo=200.0; // ,  .     
extern double ProfitLevel=0;
extern bool HighLowOnly=false;// false - Open + High/Low, true - High+Low
extern bool Info=false; //   -
datetime TimeOpen;
bool Finish=False; 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   return(0); 
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() 
 {
  int      Period_X;
  double   vol;
  string symbol = Symbol(); 
if (TrailingStop!=0)
 {if (MinProfit==0 && TrailingStep==0)MinProfit=TrailingStop;
  TrailingPositions(symbol,MinProfit,TrailingStop,TrailingStep);}

if (Finish)return;
if (Period_at_minute==0)Period_X=Period();else Period_X=Period_at_minute;
if (NewBar(Period_X))   //  Period_X
 { 
  DeletePendig();
//----------------------------------------------------------------------------------------------------------------
// 
//----------------------------------------------------------------------------------------------------------------
if (AccountEquity() < MinDepo) {Finish=true; Print("Finit a la komedia");return;}
//if (BuyCnt+SellCnt>=MaxOrders)return;
if (OrdersTotal()>=MaxOrders)return;
if (risk>0) 
 vol=NormalizeDouble(MathCeil((AccountFreeMargin()*risk)/10000)/10,1); //    
else 
 vol=Lots; 
if (vol-MarketInfo(symbol,MODE_MINLOT)<0)vol=MarketInfo(symbol,MODE_MINLOT);
if (NormalizeDouble(vol-MarketInfo(symbol,MODE_MAXLOT),1)>0)
 vol=MarketInfo(symbol,MODE_MAXLOT); 
//----------------------------------------------------------------------
//  
//----------------------------------------------------------------------
if (Pips!=0)
  {
  //-------------  BuyStop  Pips  -----------------------------
      if (!CmdExists(OP_BUY))
       {double OpenPrice=Ask+Pips*Point;
        if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
        if (!PendingInstall(vol,OP_BUYSTOP,OpenPrice))
        Print("    BuyStop");
       }

  //-------------  SellStop  Pips ----------------------------       
      if (!CmdExists(OP_SELL))
       {OpenPrice=Bid-Pips*Point;
        if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
        if (!PendingInstall(vol,OP_SELLSTOP,OpenPrice))
        Print("    SellStop");
       }
   }
else 
 if (!HighLowOnly) 
  { 
   if ((iOpen(symbol,Period_X,1) -iClose(symbol,Period_X,1))/Point-Body >0 ) //   
      {
  //-------------  BuyStop  n ----------------------------------
       if (!CmdExists(OP_BUY))
        {OpenPrice=iOpen(symbol,Period_X,1);
         if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
         if (!PendingInstall(vol,OP_BUYSTOP,OpenPrice))
         Print("    BuyStop");
        } 
  //-------------  SellStop  Low ----------------------------------      
       if (!CmdExists(OP_SELL))
        {OpenPrice=iLow(symbol,Period_X,1);
         if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
         if (!PendingInstall(vol,OP_SELLSTOP,OpenPrice))
         Print("    SellStop"); 
        } 
      }
   if ((iClose(symbol,Period_X,1) -iOpen(symbol,Period_X,1))/Point-Body >0 ) //   
     {
   //-------------  BuyStop  High ---------------------------------
      if (!CmdExists(OP_BUY)) // && (!CmdExists(OP_SELL) || CmdProfit(OP_SELL)-ProfitLevel*Point<0))
       {OpenPrice=iHigh(symbol,Period_X,1);
        if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
        if (!PendingInstall(vol,OP_BUYSTOP,OpenPrice))
        Print("    BuyStop");
       }
  //-------------  SellStop  Open ----------------------------------      
      if (!CmdExists(OP_SELL))
       {OpenPrice=iOpen(symbol,Period_X,1);
        if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
        if (!PendingInstall(vol,OP_SELLSTOP,OpenPrice))
        Print("    SellStop");
       } 
     }   
   } 
 else
  {
  //-------------  BuyStop  High -----------------------------------
      {if (!CmdExists(OP_BUY))
        {OpenPrice=iHigh(symbol,Period_X,1);
         if (OpenPrice-Ask-MODE_STOPLEVEL*Point<0) OpenPrice=Ask+MODE_STOPLEVEL*Point;
         if (!PendingInstall(vol,OP_BUYSTOP,OpenPrice))
         Print("    BuyStop");
        }
  //-------------  SellStop  Low ----------------------------------      
       if (!CmdExists(OP_SELL))
        {OpenPrice=iLow(symbol,Period_X,1);
         if (Bid-MODE_STOPLEVEL*Point-OpenPrice<0) OpenPrice=Bid-MODE_STOPLEVEL*Point;
         if (!PendingInstall(vol,OP_SELLSTOP,OpenPrice))
         Print("    SellStop");
        } 
      }
  }
 } //  NewBar  
return; 	
} // start() 
//+------------------------------------------------------------------+


bool NewBar(int Period_X)
   {
    bool result=false;
    if (TimeOpen!=iTime(NULL,Period_X,0))   // 
     {result=true;
      TimeOpen=iTime(NULL,Period_X,0);}
    return(result);
   }
//+------------------------------------------------------------------+
//|void TrailingPositions() function                                     |
//+------------------------------------------------------------------+
void TrailingPositions(string symbol,int MinProfit,int TrailingStop,int TrailingStep) 
{
  int cnt = OrdersTotal();

  for (int i=0; i<cnt; i++) { 
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {int error_code = GetLastError();
  Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
  return ;
      }
    if (OrderSymbol() != symbol || MAGIC != OrderMagicNumber()) continue;        

    if (OrderType() == OP_BUY) {
      if (NormalizeDouble(MarketInfo( symbol, MODE_BID) -OrderOpenPrice()-MinProfit*MarketInfo( symbol, MODE_POINT),Digits) > 0) {
        if (NormalizeDouble(MarketInfo( symbol, MODE_BID)-(TrailingStop+TrailingStep)*MarketInfo( symbol, MODE_POINT)-OrderStopLoss(),Digits)>0) {
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), MarketInfo( symbol, MODE_BID)-TrailingStop*MarketInfo( symbol, MODE_POINT), OrderTakeProfit(), 0, Aqua))
         {error_code = GetLastError();
  Print("Error modify order : ", ErrorDescription(error_code), " (", error_code, ")");
  Sleep(10000);RefreshRates( );
  return ;
          }  
        }
      }
    }

    if (OrderType() == OP_SELL) {
      if (NormalizeDouble(OrderOpenPrice()-MarketInfo( symbol, MODE_ASK)-MinProfit*MarketInfo( symbol, MODE_POINT),Digits) > 0) {
        if (NormalizeDouble(MarketInfo( symbol, MODE_ASK)+(TrailingStop+TrailingStep)*MarketInfo( symbol, MODE_POINT)-OrderStopLoss(),Digits)<0 || OrderStopLoss() == 0) {
        if (!OrderModify(OrderTicket(), OrderOpenPrice(), MarketInfo( symbol, MODE_ASK)+TrailingStop*MarketInfo( symbol, MODE_POINT), OrderTakeProfit(), 0, Yellow))
         {error_code = GetLastError();
  Print("Error modify order : ", ErrorDescription(error_code), " (", error_code, ")");
  Sleep(10000);RefreshRates( );
  return ;
         }
        }
      }
    }
  }
return ;
}
 //----------------------------------------------------------------------
 //bool CmdExists() function                                              |
 //---------------------------------------------------------------------- 
 bool CmdExists(int cmd)
 { bool result=false;
   int total=OrdersTotal(); 
   for (int i=total-1;i>=0;i--)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return ;
      }
	  if ( OrderSymbol()!=Symbol() || MAGIC != OrderMagicNumber())     	
		continue;                        
  	  else
      if (OrderType() == cmd) result=true;    //    
    }  
 return(result);
 }
//+------------------------------------------------------------------+
//|bool DeleteStopOrders() function                                  |
//+------------------------------------------------------------------+
bool DeletePendig()
 {  
   int total=OrdersTotal(); 
   for (int i=total-1;i>=0;i--)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return(false);
      }
	  if (OrderSymbol() != Symbol() || MAGIC != OrderMagicNumber())     	
		continue;                        
     if (
         (OrderType()==OP_BUYSTOP && (OrderOpenPrice()-Ask)/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL)) ||
	      (OrderType()==OP_SELLSTOP && (Bid-OrderOpenPrice())/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL))||
	      (OrderType()==OP_BUYLIMIT && (Ask-OrderOpenPrice())/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL))||
	      (OrderType()==OP_SELLLIMIT && (OrderOpenPrice()-Bid)/Point>MarketInfo(Symbol(),MODE_FREEZELEVEL))
	     )
     if (!OrderDelete(OrderTicket()))
	         {
	          error_code = GetLastError();
             Print("Error OrderDelete function: ", ErrorDescription(error_code), " (", error_code, ")");
             Sleep(10000);RefreshRates();
             return(false);
            }
    } //  for
   return(true);
 }
//+------------------------------------------------------------------+
//|bool PendingInstall() function                                    |
//+------------------------------------------------------------------+
bool PendingInstall(double vol,int cmd, double OpenPrice)
 {    
     double Sl=0;double Tp=0; bool result=true;
     if (cmd==OP_BUYSTOP || cmd==OP_BUYLIMIT)
     {
      if (StopLoss>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Sl=OpenPrice-StopLoss*Point;
      if (TakeProfit>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Tp=OpenPrice+TakeProfit*Point; 
      if (Info)Print("Ask=",Ask," Buy: OpenPrice=",OpenPrice," StopLoss=",Sl," TakeProfit=",Tp);
     } 
     if (cmd==OP_SELLSTOP|| cmd==OP_SELLLIMIT)
     { 
      if (StopLoss>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Sl=OpenPrice+StopLoss*Point;
      if (TakeProfit>MarketInfo(Symbol(),MODE_STOPLEVEL))
        Tp=OpenPrice-TakeProfit*Point;
      if (Info)Print("Bid=",Bid," Sell: OpenPrice=",OpenPrice," StopLoss=",Sl," TakeProfit=",Tp);
     } 
      int ticket=OrderSend(Symbol(),cmd,vol,OpenPrice,5,Sl,Tp,"",MAGIC, 0 , Yellow); 
      if (ticket<=0)
        {
         result=false;
         int error_code = GetLastError();
         Print("Error opening order : ", ErrorDescription(error_code), " (", error_code, ")");
        }
       Sleep(10000);RefreshRates();
      return(result);
  }
//----------------------------------------------------------------------
//double CmdProfit() function                                            |
//---------------------------------------------------------------------- 
 double CmdProfit(int cmd)
 { double result;
   int total=OrdersTotal(); 
   for (int i=total-1;i>=0;i--)       
	 { 	
     if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) 
      {
       int error_code = GetLastError();
       Print("Error OrderSelect function: ", ErrorDescription(error_code), " (", error_code, ")");
       return ;
      }
	  if ( OrderSymbol()!=Symbol() || MAGIC != OrderMagicNumber())     	
		continue;                        
  	  else
      if (OrderType() == cmd) result+=OrderProfit(); 
    }  
 return(result);
 }     